#lang racket
(require rackunit)

(define set-subset? identity)

; ----------------------------------------------------------------------

(define set-equals?
  (lambda (S1 S2)
    (and (set-subset? S1 S2)
         (set-subset? S2 S1))))

; ----------------------------------------------------------------------

(define ex
  (lambda ()
    (let ((x 3) (y 4))
      (+ (let ((z 5)
               (x (* 3 y)))
           (+ (* x y) z))
         (let ((x 6)
               (w (- x y)))
           (+ (* x w) y))))))

; ----------------------------------------------------------------------

(define invert
  (lambda (list-of-2-lists)
    (let ((swap (lambda (lst)                                            
                  (list (second lst) (first lst)))))
      (map swap list-of-2-lists)) ))

; ----------------------------------------------------------------------
; list-index, with a stand-alone helper function
; ----------------------------------------------------------------------

(define list-index
  (lambda (target los)
    (list-index-counted target los 0)))

(define list-index-counted
  (lambda (target los count)
    (if (null? los)
        -1
        (if (eq? target (first los))
            count
            (list-index-counted target (rest los) (add1 count))))))

; ----------------------------------------------------------------------

(check-equal? (ex) 51)

; ----------------------------------------------------------------------